# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['JwtIssuerArgs', 'JwtIssuer']

@pulumi.input_type
class JwtIssuerArgs:
    def __init__(__self__, *,
                 audience: pulumi.Input[str],
                 issuer_url: pulumi.Input[str],
                 claim: Optional[pulumi.Input[str]] = None,
                 identity_maps: Optional[pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]]] = None,
                 jwks: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a JwtIssuer resource.
        :param pulumi.Input[str] audience: The intended audience for consuming the JWT.
        :param pulumi.Input[str] issuer_url: The URL of the server issuing JWTs.
        :param pulumi.Input[str] claim: Used to identify the user from the external Identity Provider. Defaults to "sub".
        :param pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]] identity_maps: A list of mappings to map the external token identity into CockroachDB Cloud.
        :param pulumi.Input[str] jwks: A set of public keys (JWKS) used to verify the JWT.
        """
        pulumi.set(__self__, "audience", audience)
        pulumi.set(__self__, "issuer_url", issuer_url)
        if claim is not None:
            pulumi.set(__self__, "claim", claim)
        if identity_maps is not None:
            pulumi.set(__self__, "identity_maps", identity_maps)
        if jwks is not None:
            pulumi.set(__self__, "jwks", jwks)

    @property
    @pulumi.getter
    def audience(self) -> pulumi.Input[str]:
        """
        The intended audience for consuming the JWT.
        """
        return pulumi.get(self, "audience")

    @audience.setter
    def audience(self, value: pulumi.Input[str]):
        pulumi.set(self, "audience", value)

    @property
    @pulumi.getter(name="issuerUrl")
    def issuer_url(self) -> pulumi.Input[str]:
        """
        The URL of the server issuing JWTs.
        """
        return pulumi.get(self, "issuer_url")

    @issuer_url.setter
    def issuer_url(self, value: pulumi.Input[str]):
        pulumi.set(self, "issuer_url", value)

    @property
    @pulumi.getter
    def claim(self) -> Optional[pulumi.Input[str]]:
        """
        Used to identify the user from the external Identity Provider. Defaults to "sub".
        """
        return pulumi.get(self, "claim")

    @claim.setter
    def claim(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "claim", value)

    @property
    @pulumi.getter(name="identityMaps")
    def identity_maps(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]]]:
        """
        A list of mappings to map the external token identity into CockroachDB Cloud.
        """
        return pulumi.get(self, "identity_maps")

    @identity_maps.setter
    def identity_maps(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]]]):
        pulumi.set(self, "identity_maps", value)

    @property
    @pulumi.getter
    def jwks(self) -> Optional[pulumi.Input[str]]:
        """
        A set of public keys (JWKS) used to verify the JWT.
        """
        return pulumi.get(self, "jwks")

    @jwks.setter
    def jwks(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "jwks", value)


@pulumi.input_type
class _JwtIssuerState:
    def __init__(__self__, *,
                 audience: Optional[pulumi.Input[str]] = None,
                 claim: Optional[pulumi.Input[str]] = None,
                 identity_maps: Optional[pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]]] = None,
                 issuer_url: Optional[pulumi.Input[str]] = None,
                 jwks: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering JwtIssuer resources.
        :param pulumi.Input[str] audience: The intended audience for consuming the JWT.
        :param pulumi.Input[str] claim: Used to identify the user from the external Identity Provider. Defaults to "sub".
        :param pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]] identity_maps: A list of mappings to map the external token identity into CockroachDB Cloud.
        :param pulumi.Input[str] issuer_url: The URL of the server issuing JWTs.
        :param pulumi.Input[str] jwks: A set of public keys (JWKS) used to verify the JWT.
        """
        if audience is not None:
            pulumi.set(__self__, "audience", audience)
        if claim is not None:
            pulumi.set(__self__, "claim", claim)
        if identity_maps is not None:
            pulumi.set(__self__, "identity_maps", identity_maps)
        if issuer_url is not None:
            pulumi.set(__self__, "issuer_url", issuer_url)
        if jwks is not None:
            pulumi.set(__self__, "jwks", jwks)

    @property
    @pulumi.getter
    def audience(self) -> Optional[pulumi.Input[str]]:
        """
        The intended audience for consuming the JWT.
        """
        return pulumi.get(self, "audience")

    @audience.setter
    def audience(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "audience", value)

    @property
    @pulumi.getter
    def claim(self) -> Optional[pulumi.Input[str]]:
        """
        Used to identify the user from the external Identity Provider. Defaults to "sub".
        """
        return pulumi.get(self, "claim")

    @claim.setter
    def claim(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "claim", value)

    @property
    @pulumi.getter(name="identityMaps")
    def identity_maps(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]]]:
        """
        A list of mappings to map the external token identity into CockroachDB Cloud.
        """
        return pulumi.get(self, "identity_maps")

    @identity_maps.setter
    def identity_maps(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['JwtIssuerIdentityMapArgs']]]]):
        pulumi.set(self, "identity_maps", value)

    @property
    @pulumi.getter(name="issuerUrl")
    def issuer_url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL of the server issuing JWTs.
        """
        return pulumi.get(self, "issuer_url")

    @issuer_url.setter
    def issuer_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "issuer_url", value)

    @property
    @pulumi.getter
    def jwks(self) -> Optional[pulumi.Input[str]]:
        """
        A set of public keys (JWKS) used to verify the JWT.
        """
        return pulumi.get(self, "jwks")

    @jwks.setter
    def jwks(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "jwks", value)


class JwtIssuer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 audience: Optional[pulumi.Input[str]] = None,
                 claim: Optional[pulumi.Input[str]] = None,
                 identity_maps: Optional[pulumi.Input[Sequence[pulumi.Input[Union['JwtIssuerIdentityMapArgs', 'JwtIssuerIdentityMapArgsDict']]]]] = None,
                 issuer_url: Optional[pulumi.Input[str]] = None,
                 jwks: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configuration to manage external JSON Web Token (JWT) Issuers for authentication to the CockroachDB Cloud API.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] audience: The intended audience for consuming the JWT.
        :param pulumi.Input[str] claim: Used to identify the user from the external Identity Provider. Defaults to "sub".
        :param pulumi.Input[Sequence[pulumi.Input[Union['JwtIssuerIdentityMapArgs', 'JwtIssuerIdentityMapArgsDict']]]] identity_maps: A list of mappings to map the external token identity into CockroachDB Cloud.
        :param pulumi.Input[str] issuer_url: The URL of the server issuing JWTs.
        :param pulumi.Input[str] jwks: A set of public keys (JWKS) used to verify the JWT.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: JwtIssuerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configuration to manage external JSON Web Token (JWT) Issuers for authentication to the CockroachDB Cloud API.

        :param str resource_name: The name of the resource.
        :param JwtIssuerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(JwtIssuerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 audience: Optional[pulumi.Input[str]] = None,
                 claim: Optional[pulumi.Input[str]] = None,
                 identity_maps: Optional[pulumi.Input[Sequence[pulumi.Input[Union['JwtIssuerIdentityMapArgs', 'JwtIssuerIdentityMapArgsDict']]]]] = None,
                 issuer_url: Optional[pulumi.Input[str]] = None,
                 jwks: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = JwtIssuerArgs.__new__(JwtIssuerArgs)

            if audience is None and not opts.urn:
                raise TypeError("Missing required property 'audience'")
            __props__.__dict__["audience"] = audience
            __props__.__dict__["claim"] = claim
            __props__.__dict__["identity_maps"] = identity_maps
            if issuer_url is None and not opts.urn:
                raise TypeError("Missing required property 'issuer_url'")
            __props__.__dict__["issuer_url"] = issuer_url
            __props__.__dict__["jwks"] = jwks
        super(JwtIssuer, __self__).__init__(
            'cockroach:index/jwtIssuer:JwtIssuer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            audience: Optional[pulumi.Input[str]] = None,
            claim: Optional[pulumi.Input[str]] = None,
            identity_maps: Optional[pulumi.Input[Sequence[pulumi.Input[Union['JwtIssuerIdentityMapArgs', 'JwtIssuerIdentityMapArgsDict']]]]] = None,
            issuer_url: Optional[pulumi.Input[str]] = None,
            jwks: Optional[pulumi.Input[str]] = None) -> 'JwtIssuer':
        """
        Get an existing JwtIssuer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] audience: The intended audience for consuming the JWT.
        :param pulumi.Input[str] claim: Used to identify the user from the external Identity Provider. Defaults to "sub".
        :param pulumi.Input[Sequence[pulumi.Input[Union['JwtIssuerIdentityMapArgs', 'JwtIssuerIdentityMapArgsDict']]]] identity_maps: A list of mappings to map the external token identity into CockroachDB Cloud.
        :param pulumi.Input[str] issuer_url: The URL of the server issuing JWTs.
        :param pulumi.Input[str] jwks: A set of public keys (JWKS) used to verify the JWT.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _JwtIssuerState.__new__(_JwtIssuerState)

        __props__.__dict__["audience"] = audience
        __props__.__dict__["claim"] = claim
        __props__.__dict__["identity_maps"] = identity_maps
        __props__.__dict__["issuer_url"] = issuer_url
        __props__.__dict__["jwks"] = jwks
        return JwtIssuer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def audience(self) -> pulumi.Output[str]:
        """
        The intended audience for consuming the JWT.
        """
        return pulumi.get(self, "audience")

    @property
    @pulumi.getter
    def claim(self) -> pulumi.Output[Optional[str]]:
        """
        Used to identify the user from the external Identity Provider. Defaults to "sub".
        """
        return pulumi.get(self, "claim")

    @property
    @pulumi.getter(name="identityMaps")
    def identity_maps(self) -> pulumi.Output[Optional[Sequence['outputs.JwtIssuerIdentityMap']]]:
        """
        A list of mappings to map the external token identity into CockroachDB Cloud.
        """
        return pulumi.get(self, "identity_maps")

    @property
    @pulumi.getter(name="issuerUrl")
    def issuer_url(self) -> pulumi.Output[str]:
        """
        The URL of the server issuing JWTs.
        """
        return pulumi.get(self, "issuer_url")

    @property
    @pulumi.getter
    def jwks(self) -> pulumi.Output[Optional[str]]:
        """
        A set of public keys (JWKS) used to verify the JWT.
        """
        return pulumi.get(self, "jwks")

